%% Main file
clear all
%% Collecting the data
data_differential

%% Kinematic analysis 
% Computing the table of links and joints of the system
T=jointtable(differentiel);

% Computing the adjacency matrix 
M=kinemod(differentiel);


% Number of degree of freedom
Ndof=size(M,2)-rank(M);

% Computing the speed ratio matrix
Rep=null(M);

%% Imposing the car frame speed to 0 and normalizing with respect to two
% wheels.
aux=null(M(:,2:end));
W=aux*inv(aux(2:3,1:2));

%% Nominal behaviour : driving straight ahead 
% The carter is fixed to 0 and the two wheels turn at the same speed
% The speed ratio vector is normalized with respect to the transmission
aux=null([M(:,2:end);0 1 -1 0 0 0]);
W=aux*inv(aux(1,1));
W=[0;aux];
% Inventaire des d�fauts:
def=default(differentiel,W);

%% The car is jacked up
% It means the transmission speed is set to 0. Then the Speed ratio vector
% is normalized with respect to the wheels.
aux=null(M(:,3:end));
W=[0 ; 0 ; aux*inv(aux(1,1))];


%% Numerical application 
aux=null(M(:,2:end));
aux=aux*inv(aux(2:3,1:2));
W=aux*[26;30];
W=[0;W];
def=default(differentiel,W);